#ifndef _GRECWIN_H_
#define _GRECWIN_H

#include <gwin.h>

// the following types are `local'; i.e., internal for Grecwin
struct GLineInfoScreen
{
    int
    	x1, y1, x2, y2;
};

struct GLineInfoVirtual
{
    double
    	x1, y1, x2, y2;
};

struct GDotInfoScreen
{
    int
    	x, y;
};

struct GDotInfoVirtual
{
    double
    	x, y;
};

union GAnyInfo
{
    GLineInfoScreen
    	scr_line;
    GLineInfoVirtual
    	vir_line;
    GDotInfoScreen
    	scr_dot;
    GDotInfoVirtual
    	vir_dot;
};

enum GType
{
    type_scr_line,
    type_vir_line,
    type_scr_dot,
    type_vir_dot,
};

struct GItem
{
    GType 
        type;
    GAnyInfo
    	obj;
};

// and, here's the class definition
class Grecwin: public Gwin
{
    public:
    	Grecwin ();				// default constructor
    	Grecwin (int mode);			// constructor w/ video mode
    	~Grecwin ();				// destructor
    	
    	void record_on ();			// start recording
    	void record_off ();			// end recording
    	void redraw (int fg);			// redraw window with color
    	
    	void drawdot (int x, int y);		// overloaded drawdot
    	void drawdot (double x, double y);
    	void drawline (int x1, int y1, int x2,	// and drawline
     	    int y2);
        void drawline (double x1, double y1,
            double x2, double y2);
    	
    private:
    	void newobject ();			// create space for obj
    	
    	int recording;				// recording or not?
    	GItem *object;				// array of drawn objects
    	int nobject;				// # of objects stored
};

#endif
